// We `recycle` because we need fresh processes because of fs patching.
({babel: true, recycle: true, delay: 500})

import fs from 'fs'
import createFixturesDir from '../../create-fixtures-dir'
import glob from 'glob'
import fg from 'fast-glob'

const vol = createFixturesDir()

let a

fs.writeFileSync('/app/foo.json', 'foo')

// Results
glob.sync('/app') // ? ['/app']
fg.sync('/app') // ? [] Because we don't read entries inside directory (will be fixed by #47)

fs.writeFileSync('/app/foo.json', 'foo') //?
fs.symlinkSync('/app', '/app/foo') //?

// Results
console.log(glob.sync('/app/*')) // ? ['/app']
console.log(fg.sync('/app/*')) // ? [] Because we don't read entries inside directory (will be fixed by #47)

console.log(glob.sync('/app/foo/*')) // ? ['/app']
console.log(fg.sync('/app/foo/*')) //?

glob.sync('./app/*'); // ? [ 'app', 'app/foo', 'app/foo.json' ]
fg.sync('./app/*', { onlyFiles: false }); // ? [ 'app/foo', 'app/foo.json' ]
