'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {

  var compileTimes = {};

  // TODO(vjpr): I think this has to be run after our hooks are setup.

  // NOTE: This will also capture some of the requires that `babel-register` does. (So not just compilation.)

  // We wrap everything in `require.extension. map.
  // NOTE: Extensions call _compile.
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    var _loop = function _loop() {
      var ext = _step.value;

      var origExtension = require.extensions[ext];
      require.extensions[ext] = function (m, filename) {
        //
        // -> Before transform runs
        //
        //const info = compileTimes[filename + ':' + ext] = {start: now()}
        var info = compileTimes[filename] = { start: (0, _performanceNow2.default)() };
        var origCompile = m._compile;
        m._compile = function (content, filename) {
          //
          // -> After transform runs
          //
          info.end = (0, _performanceNow2.default)();
          info.duration = info.end - info.start;
          origCompile.call(m, content, filename);
        };
        var result = origExtension(m, filename);
        return result;
      };
    };

    for (var _iterator = Object.keys(require.extensions)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      _loop();
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return compileTimes;
};

var _performanceNow = require('performance-now');

var _performanceNow2 = _interopRequireDefault(_performanceNow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
//# sourceMappingURL=compile-times.js.map