'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {

  var ctx = {
    // For finding dupes.
    requestToFilename: {},
    config: {
      printDupesShowRequester: false,
      printDupes: false,
      showFullPath: true,
      truncatePaths: true
    }
  };

  return {
    start: function start() {
      return _start(ctx);
    },
    end: function end() {
      return _end(ctx);
    }
  };
};

var _path = require('path');

var _treeModel = require('tree-model');

var _treeModel2 = _interopRequireDefault(_treeModel);

var _printCallTree = require('./print-call-tree');

var _printCallTree2 = _interopRequireDefault(_printCallTree);

var _printDupes = require('./print-dupes');

var _printDupes2 = _interopRequireDefault(_printDupes);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _chalkline = require('chalkline');

var _chalkline2 = _interopRequireDefault(_chalkline);

var _compileTimes = require('./compile-times');

var _compileTimes2 = _interopRequireDefault(_compileTimes);

var _requireTimes = require('./require-times');

var _requireTimes2 = _interopRequireDefault(_requireTimes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _start(ctx) {
  var tree = new _treeModel2.default();
  var root = tree.parse({ path: '<root>', duration: 0, childrenDuration: 0 });
  var requestToFilename = ctx.requestToFilename;


  var compileTimes = (0, _compileTimes2.default)();
  (0, _requireTimes2.default)({ root: root, tree: tree, requestToFilename: requestToFilename });

  Object.assign(ctx, { root: root, compileTimes: compileTimes, maxDepth: Infinity });
}

// TODO(vjpr): Api could be better.


function _end(ctx) {
  console.log();
  _chalkline2.default.grey();
  console.log();
  console.log(_chalk2.default.bold('REQUIRE TIMINGS from require-clock'));
  var root = ctx.root,
      compileTimes = ctx.compileTimes,
      maxDepth = ctx.maxDepth,
      requestToFilename = ctx.requestToFilename,
      config = ctx.config;

  (0, _printCallTree2.default)({ root: root, compileTimes: compileTimes, maxDepth: maxDepth, config: config });
  if (config.printDupes) (0, _printDupes2.default)({ requestToFilename: requestToFilename, config: config });
}
//# sourceMappingURL=index.js.map