'use strict';

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function printTree(initialTree, printNode, getChildren) {
  function printBranch(tree, branch) {
    var isGraphHead = branch.length === 0;
    var children = getChildren(tree) || [];

    var branchHead = '';

    if (!isGraphHead) {
      branchHead = children && children.length !== 0 ? '┬ ' : '─ ';
    }

    var toPrint = printNode(tree, '' + branch + branchHead);

    if (typeof toPrint === 'string') {
      console.log('' + branch + branchHead + toPrint);
    }

    var baseBranch = branch;

    if (!isGraphHead) {
      var isChildOfLastBranch = branch.slice(-2) === '└─';
      baseBranch = branch.slice(0, -2) + (isChildOfLastBranch ? '  ' : '| ');
    }

    var nextBranch = baseBranch + '├─';
    var lastBranch = baseBranch + '└─';

    children.forEach(function (child, index) {
      printBranch(child, _chalk2.default.grey(children.length - 1 === index ? lastBranch : nextBranch));
    });
  }

  printBranch(initialTree, '');
} // From https://github.com/alex-e-leon/print-tree/blob/master/index.js

module.exports = printTree;
//# sourceMappingURL=print-tree.js.map