'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var root = _ref.root;


  // TODO(vjpr): Sort children by require time?

  var standardHelpStr = '\n  - Top-down time spent requiring (> 20ms).\n  - Yellow shows time spent running self (vs. requiring child modules).';

  function end() {

    console.log();
    _chalkline2.default.grey();
    console.log(_chalk2.default.grey(standardHelpStr));
    console.log();

    var sortChildren = false;
    var indentSize = 2;
    var threshold = 20;
    var _out = out,
        root = _out.root,
        compileTimes = _out.compileTimes,
        _out$maxDepth = _out.maxDepth,
        maxDepth = _out$maxDepth === undefined ? Infinity : _out$maxDepth;

    root.walk({ strategy: 'pre' }, function (node) {
      var depth = node.getPath().length;
      //const depth = node.model.depth

      //console.log(node)

      if (depth > maxDepth) return;
      var _node$model = node.model,
          childrenDuration = _node$model.childrenDuration,
          duration = _node$model.duration,
          path = _node$model.path,
          filename = _node$model.filename;


      if (!duration) return;
      if (duration < threshold) return;

      var compileTime = _lodash2.default.get(compileTimes[filename], 'duration');
      // Time spent running file excluding require calls and source transforms.
      var nonRequireTime = duration - (childrenDuration + compileTime);
      var str = '';
      if (duration) {
        var color = (0, _util.getColorForDuration)(duration);
        str += ms(duration, color);
      }
      str += ' ';
      str += path;
      str += ' ';
      if (nonRequireTime > 10) str += _chalk2.default.yellow.dim('self=') + ms(nonRequireTime, 'yellow.dim');
      str += ' ';
      if (compileTime > 10) str += ms(compileTime, 'red.dim', 2);
      //str += ' f: ' + chalk.gray(filename)
      var indentChars = Array(depth * indentSize).join(' ') + _chalk2.default.grey('| ');
      //const indentChars = node.model.depth * indentSize
      str = (0, _indent2.default)(str, indentChars);
      console.log(str);
    });
  }
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _chalkline = require('chalkline');

var _chalkline2 = _interopRequireDefault(_chalkline);

var _indent = require('indent');

var _indent2 = _interopRequireDefault(_indent);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _isBuiltinModule = require('is-builtin-module');

var _isBuiltinModule2 = _interopRequireDefault(_isBuiltinModule);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _treeModel = require('tree-model');

var _treeModel2 = _interopRequireDefault(_treeModel);

var _performanceNow = require('performance-now');

var _performanceNow2 = _interopRequireDefault(_performanceNow);

var _module = require('module');

var _module2 = _interopRequireDefault(_module);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
//# sourceMappingURL=print.js.map