'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var root = _ref.root,
      tree = _ref.tree,
      requestToFilename = _ref.requestToFilename;

  // You could just re-use the existing tree like require-times does.
  // But, we want to add additional info to the nodes. More convenient I think.

  var current = root;

  _module2.default.prototype.requireOrig = _module2.default.prototype.require;
  _module2.default.prototype.require = function (request) {
    var parent = this;

    var childrenDuration = 0;
    var childrenResolveTime = 0;
    var childrenCount = 0;

    var startTime = (0, _performanceNow2.default)();

    var node = tree.parse({
      path: request,
      startTime: startTime,
      childrenDuration: childrenDuration,
      childrenResolveTime: childrenResolveTime,
      childrenCount: childrenCount
    });
    current.addChild(node);
    current = node;

    var isMain = false;

    var filename = _module2.default._resolveFilename(request, parent, isMain);
    node.model.resolveTime = (0, _performanceNow2.default)() - startTime;
    var cachedModule = _module2.default._cache[filename];
    if (cachedModule) node.model.cached = true;

    // Needed so we can print dupes.
    if (isModuleRequest(request)) {
      _lodash2.default.set(requestToFilename, [request, filename], { node: node });
    }

    // Resolves filename, get or set module to cache
    var result = this.requireOrig(request);
    //const result = Module._load(request, this)

    node.model.requester = parent.filename;
    node.model.filename = filename;
    node.model.endTime = (0, _performanceNow2.default)();
    node.model.duration = node.model.endTime - node.model.startTime;

    // Add our duration to parents.
    node.parent.model.childrenCount++;
    node.parent.model.childrenDuration += node.model.duration;
    node.parent.model.childrenResolveTime += node.model.resolveTime;
    current = node.parent;

    return result;
  };
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _isBuiltinModule = require('is-builtin-module');

var _isBuiltinModule2 = _interopRequireDefault(_isBuiltinModule);

var _path = require('path');

var _performanceNow = require('performance-now');

var _performanceNow2 = _interopRequireDefault(_performanceNow);

var _module = require('module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isModuleRequest(request) {
  return !request.startsWith('.') && !(0, _isBuiltinModule2.default)(request);
}
//# sourceMappingURL=require-times.js.map