'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getColorForDuration = getColorForDuration;
exports.ms = ms;
exports.printCompileTimes = printCompileTimes;
exports.printHelp = printHelp;

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _chalkline = require('chalkline');

var _chalkline2 = _interopRequireDefault(_chalkline);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getColorForDuration(duration) {
  return duration > 100 ? 'bgRed' : duration > 50 ? 'bgYellow' : 'green';
}

function ms(value) {
  var color = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'white';
  var digits = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

  (0, _assert2.default)(!_lodash2.default.isUndefined(value));
  var str = value.toFixed(digits) + 'ms';
  //str = _.padStart(str, 6)
  str = _lodash2.default.get(_chalk2.default, color)(str);
  return str;
}

function printCompileTimes(compileTimes) {
  (0, _lodash2.default)(compileTimes).each(function (v, k) {
    return console.log(k + ' ' + _chalk2.default.green(v.duration.toFixed(2)) + 'ms');
  }).run();
}

function printHelp(heading, contents) {
  console.log();
  _chalkline2.default.grey();
  console.log();
  console.log(_chalk2.default.bold(heading));
  console.log(_chalk2.default.grey(contents));
  console.log();
}
//# sourceMappingURL=util.js.map