'use strict';

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO(vjpr): If we ignore certain elements it doesn't print the closing properly.

function printTree(initialTree, printNode, getChildren) {
  function printBranch(tree, branch) {
    var isGraphHead = branch.length === 0;
    var children = getChildren(tree) || [];
    var verticalLine = '│ '; // taken from `/bin/sh tree` command.
    //const verticalLine = '| '

    var branchHead = '';

    if (!isGraphHead) {
      branchHead = children && children.length !== 0 ? '┬ ' : '─ ';
    }

    var toPrint = printNode(tree, '' + branch + branchHead, branch.length);

    if (typeof toPrint === 'string') {
      var branchStr = _chalk2.default.grey(branch + branchHead);
      console.log('' + branchStr + toPrint);
    }

    var baseBranch = branch;

    if (!isGraphHead) {
      var isChildOfLastBranch = branch.slice(-2) === '└─';
      baseBranch = branch.slice(0, -2) + (isChildOfLastBranch ? '  ' : verticalLine);
    }

    var nextBranch = baseBranch + '├─';
    var lastBranch = baseBranch + '└─';

    children.forEach(function (child, index) {
      printBranch(child, children.length - 1 === index ? lastBranch : nextBranch);
    });
  }

  printBranch(initialTree, '');
} // From https://github.com/alex-e-leon/print-tree/blob/master/index.js

module.exports = printTree;
//# sourceMappingURL=print-tree.js.map