import now from 'performance-now'

export default function() {

  const compileTimes = {}

  // TODO(vjpr): I think this has to be run after our hooks are setup.

  // NOTE: This will also capture some of the requires that `babel-register` does. (So not just compilation.)

  // We wrap everything in `require.extension. map.
  // NOTE: Extensions call _compile.
  for (let ext of Object.keys(require.extensions)) {
    const origExtension = require.extensions[ext]
    require.extensions[ext] = function(m, filename) {
      //
      // -> Before transform runs
      //
      //const info = compileTimes[filename + ':' + ext] = {start: now()}
      const info = compileTimes[filename] = {start: now()}
      const origCompile = m._compile
      m._compile = function(content, filename) {
        //
        // -> After transform runs
        //
        info.end = now()
        info.duration = info.end - info.start
        origCompile.call(m, content, filename)
      }
      const result = origExtension(m, filename)
      return result
    }
  }

  return compileTimes

}
