import assert from 'assert'
import _ from 'lodash'
import chalk from 'chalk'
import cl from 'chalkline'
import c from 'chalk'

export function getColorForDuration(duration) {
  return duration > 100 ? 'bgRed' : (duration > 50 ? 'bgYellow' : 'green')
}

export function ms(value, color = 'white', digits = 0) {
  assert(!_.isUndefined(value))
  let str = value.toFixed(digits) + 'ms'
  //str = _.padStart(str, 6)
  str = _.get(chalk, color)(str)
  return str
}

export function printCompileTimes(compileTimes) {
  _(compileTimes)
    .each((v, k) => console.log(`${k} ${chalk.green(v.duration.toFixed(2))}ms`))
    .run()
}

export function printHelp(heading, contents) {
  console.log()
  cl.grey()
  console.log()
  console.log(c.bold(heading))
  console.log(c.grey(contents))
  console.log()
}
