// From https://github.com/alex-e-leon/print-tree/blob/master/index.js

import c from 'chalk'

// TODO(vjpr): If we ignore certain elements it doesn't print the closing properly.

function printTree(initialTree, printNode, getChildren) {
  function printBranch(tree, branch) {
    const isGraphHead = branch.length === 0
    const children = getChildren(tree) || []
    const verticalLine = '│ ' // taken from `/bin/sh tree` command.
    //const verticalLine = '| '

    let branchHead = ''

    if (!isGraphHead) {
      branchHead = children && children.length !== 0 ? '┬ ' : '─ '
    }

    const toPrint = printNode(tree, `${branch}${branchHead}`, branch.length)

    if (typeof toPrint === 'string') {
      const branchStr = c.grey(branch + branchHead)
      console.log(`${branchStr}${toPrint}`)
    }

    let baseBranch = branch

    if (!isGraphHead) {
      const isChildOfLastBranch = branch.slice(-2) === '└─'
      baseBranch = branch.slice(0, -2) + (isChildOfLastBranch ? '  ' : verticalLine)
    }

    const nextBranch = baseBranch + '├─'
    const lastBranch = baseBranch + '└─'

    children.forEach((child, index) => {
      printBranch(
        child,
        children.length - 1 === index ? lastBranch : nextBranch,
      )
    })
  }

  printBranch(initialTree, '')
}

module.exports = printTree
